'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.Panel5 = Panel5;
var _react = _interopRequireWildcard(require('react'));
var _reactNative = require('react-native');
var _reactNativeGestureHandler = require('react-native-gesture-handler');
var _reactNativeReanimated = _interopRequireWildcard(require('react-native-reanimated'));
var _utils = require('../../utils');
var _styles = require('../../styles');
var _colorKit = _interopRequireDefault(require('../../colorKit/colorKit'));
var _AppContext = _interopRequireDefault(require('../../AppContext'));
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}
function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function (nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}
function Panel5(_ref) {
  let { style = {}, selectionStyle = {} } = _ref;
  const { value, alphaValue, setColor, onGestureChange, onGestureEnd } = (0, _react.useContext)(_AppContext.default);
  const borderRadius = (0, _utils.getStyle)(style, 'borderRadius') ?? 0;
  const squareSize = (0, _reactNativeReanimated.useSharedValue)(0),
    posX = (0, _reactNativeReanimated.useSharedValue)(0),
    posY = (0, _reactNativeReanimated.useSharedValue)(0),
    adaptiveColor = (0, _reactNativeReanimated.useSharedValue)('#000');
  const selectedStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = function () {
        return {
          width: squareSize.value,
          height: squareSize.value,
          top: posY.value * squareSize.value,
          left: _utils.isRtl ? undefined : posX.value * squareSize.value,
          right: _utils.isRtl ? posX.value * squareSize.value : undefined,
          borderColor: adaptiveColor.value,
        };
      };
      _f._closure = {
        squareSize,
        posY,
        isRtl: _utils.isRtl,
        posX,
        adaptiveColor,
      };
      _f.asString =
        'function _f(){const{squareSize,posY,isRtl,posX,adaptiveColor}=jsThis._closure;{return{width:squareSize.value,height:squareSize.value,top:posY.value*squareSize.value,left:isRtl?undefined:posX.value*squareSize.value,right:isRtl?posX.value*squareSize.value:undefined,borderColor:adaptiveColor.value};}}';
      _f.__workletHash = 3693895187279;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Panels\\Panel5.tsx (24:41)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  const setAdaptiveColor = color1 => {
    const color = adaptiveColor.value === '#ffffff' ? '#000000' : '#ffffff';
    const contrast = _colorKit.default.contrastRatio(color1, adaptiveColor.value);
    adaptiveColor.value = contrast < 4.5 ? color : adaptiveColor.value;
  };
  const tap = _reactNativeGestureHandler.Gesture.Tap().onBegin(
    (function () {
      const _f = function (_ref2) {
        var _gridColors$row;
        let { x, y } = _ref2;
        if (!squareSize.value) return;
        const row = Math.floor(y / squareSize.value);
        const column = Math.floor(x / squareSize.value);
        const color =
          gridColors === null || gridColors === void 0
            ? void 0
            : (_gridColors$row = gridColors[row]) === null || _gridColors$row === void 0
            ? void 0
            : _gridColors$row[column];
        if (!color) return;
        const withOpacity = color + (alphaValue.value === 1 ? '' : (0, _utils.decimalToHex)(alphaValue.value));
        posX.value = (0, _reactNativeReanimated.withTiming)(column, {
          duration: 300,
          easing: _reactNativeReanimated.Easing.elastic(0.8),
        });
        posY.value = (0, _reactNativeReanimated.withTiming)(row, {
          duration: 300,
          easing: _reactNativeReanimated.Easing.elastic(0.8),
        });
        (0, _reactNativeReanimated.runOnJS)(setAdaptiveColor)(withOpacity);
        (0, _reactNativeReanimated.runOnJS)(setColor)(withOpacity, 50);
        (0, _reactNativeReanimated.runOnJS)(onGestureChange)(withOpacity);
        (0, _reactNativeReanimated.runOnJS)(onGestureEnd)(withOpacity);
      };
      _f._closure = {
        squareSize,
        gridColors,
        alphaValue,
        decimalToHex: _utils.decimalToHex,
        posX,
        withTiming: _reactNativeReanimated.withTiming,
        Easing: {
          elastic: _reactNativeReanimated.Easing.elastic,
        },
        posY,
        runOnJS: _reactNativeReanimated.runOnJS,
        setAdaptiveColor,
        setColor,
        onGestureChange,
        onGestureEnd,
      };
      _f.asString =
        "function _f({x:x,y:y}){const{squareSize,gridColors,alphaValue,decimalToHex,posX,withTiming,Easing,posY,runOnJS,setAdaptiveColor,setColor,onGestureChange,onGestureEnd}=jsThis._closure;{var _gridColors,_gridColors$row;if(!squareSize.value)return;const row=Math.floor(y/squareSize.value);const column=Math.floor(x/squareSize.value);const color=(_gridColors=gridColors)===null||_gridColors===void 0?void 0:(_gridColors$row=_gridColors[row])===null||_gridColors$row===void 0?void 0:_gridColors$row[column];if(!color)return;const withOpacity=color+(alphaValue.value===1?'':decimalToHex(alphaValue.value));posX.value=withTiming(column,{duration:300,easing:Easing.elastic(0.8)});posY.value=withTiming(row,{duration:300,easing:Easing.elastic(0.8)});runOnJS(setAdaptiveColor)(withOpacity);runOnJS(setColor)(withOpacity,50);runOnJS(onGestureChange)(withOpacity);runOnJS(onGestureEnd)(withOpacity);}}";
      _f.__workletHash = 8064567106881;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Panels\\Panel5.tsx (41:36)';
      return _f;
    })()
  );
  const onLayout = (0, _react.useCallback)(_ref3 => {
    let {
      nativeEvent: { layout },
    } = _ref3;
    squareSize.value = (0, _reactNativeReanimated.withTiming)(layout.width / 12 || layout.height / 10, {
      duration: 100,
    });
  }, []);
  (0, _react.useEffect)(() => {
    const initialColor = _colorKit.default.HEX(value.slice(0, 7)).toUpperCase();
    const row = gridColors.findIndex(e => e.includes(initialColor));
    if (row === -1) return;
    const column = gridColors[row].indexOf(initialColor);
    if (column === -1) return;
    posX.value = column;
    posY.value = row;
    setAdaptiveColor(initialColor);
  }, [value]);
  return /*#__PURE__*/ _react.default.createElement(
    _reactNativeGestureHandler.GestureDetector,
    {
      gesture: tap,
    },
    /*#__PURE__*/ _react.default.createElement(
      _reactNative.ImageBackground,
      {
        source: require('../../assets/grid.png'),
        onLayout: onLayout,
        style: [
          style,
          {
            position: 'relative',
            borderWidth: 0,
            padding: 0,
            aspectRatio: 1.2,
          },
        ],
        imageStyle: {
          borderRadius,
        },
        resizeMode: 'stretch',
      },
      /*#__PURE__*/ _react.default.createElement(_reactNativeReanimated.default.View, {
        style: [_styles.styles.selected, selectionStyle, selectedStyle],
      })
    )
  );
}
const gridColors = [
  [
    '#FFFFFF',
    '#EBEBEB',
    '#D6D6D6',
    '#C2C2C2',
    '#ADADAD',
    '#999999',
    '#858585',
    '#707070',
    '#5C5C5C',
    '#474747',
    '#333333',
    '#000000',
  ],
  [
    '#00374A',
    '#011D57',
    '#11053B',
    '#2E063D',
    '#3C071B',
    '#5C0701',
    '#5A1C00',
    '#583300',
    '#563D00',
    '#666100',
    '#4F5504',
    '#263E0F',
  ],
  [
    '#004D65',
    '#012F7B',
    '#1A0A52',
    '#450D59',
    '#551029',
    '#831100',
    '#7B2900',
    '#7A4A00',
    '#785800',
    '#8D8602',
    '#6F760A',
    '#38571A',
  ],
  [
    '#016E8F',
    '#0042A9',
    '#2C0977',
    '#61187C',
    '#791A3D',
    '#B51A00',
    '#AD3E00',
    '#A96800',
    '#A67B01',
    '#C4BC00',
    '#9BA50E',
    '#4E7A27',
  ],
  [
    '#008CB4',
    '#0056D6',
    '#371A94',
    '#7A219E',
    '#99244F',
    '#E22400',
    '#DA5100',
    '#D38301',
    '#D19D01',
    '#F5EC00',
    '#C3D117',
    '#669D34',
  ],
  [
    '#00A1D8',
    '#0061FD',
    '#4D22B2',
    '#982ABC',
    '#B92D5D',
    '#FF4015',
    '#FF6A00',
    '#FFAB01',
    '#FCC700',
    '#FEFB41',
    '#D9EC37',
    '#76BB40',
  ],
  [
    '#01C7FC',
    '#3A87FD',
    '#5E30EB',
    '#BE38F3',
    '#E63B7A',
    '#FE6250',
    '#FE8648',
    '#FEB43F',
    '#FECB3E',
    '#FFF76B',
    '#E4EF65',
    '#96D35F',
  ],
  [
    '#52D6FC',
    '#74A7FF',
    '#864FFD',
    '#D357FE',
    '#EE719E',
    '#FF8C82',
    '#FEA57D',
    '#FEC777',
    '#FED977',
    '#FFF994',
    '#EAF28F',
    '#B1DD8B',
  ],
  [
    '#93E3FC',
    '#A7C6FF',
    '#B18CFE',
    '#E292FE',
    '#F4A4C0',
    '#FFB5AF',
    '#FFC5AB',
    '#FED9A8',
    '#FDE4A8',
    '#FFFBB9',
    '#F1F7B7',
    '#CDE8B5',
  ],
  [
    '#CBF0FF',
    '#D2E2FE',
    '#D8C9FE',
    '#EFCAFE',
    '#F9D3E0',
    '#FFDAD8',
    '#FFE2D6',
    '#FEECD4',
    '#FEF1D5',
    '#FDFBDD',
    '#F6FADB',
    '#DEEED4',
  ],
];
//# sourceMappingURL=Panel5.js.map
