'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.Preview = Preview;
var _react = _interopRequireWildcard(require('react'));
var _reactNative = require('react-native');
var _reactNativeReanimated = _interopRequireWildcard(require('react-native-reanimated'));
var _styles = require('../styles');
var _utils = require('../utils');
var _colorKit = _interopRequireDefault(require('../colorKit/colorKit'));
var _AppContext = _interopRequireDefault(require('../AppContext'));
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}
function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function (nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}
const ReText = _ref => {
  let { text, style, hash } = _ref;
  const [color, setColor] = (0, _react.useState)(text());
  const updateText = () => {
    setColor(text());
  };
  (0, _reactNativeReanimated.useDerivedValue)(
    (function () {
      const _f = function () {
        hash.forEach(e => e.value);
        (0, _reactNativeReanimated.runOnJS)(updateText)();
      };
      _f._closure = {
        hash,
        runOnJS: _reactNativeReanimated.runOnJS,
        updateText,
      };
      _f.asString =
        'function _f(){const{hash,runOnJS,updateText}=jsThis._closure;{hash.forEach(function(e){return e.value;});runOnJS(updateText)();}}';
      _f.__workletHash = 16418844065805;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Preview.tsx (22:18)';
      return _f;
    })()
  );
  return /*#__PURE__*/ _react.default.createElement(
    _reactNativeReanimated.default.Text,
    {
      style: [_styles.styles.previewInitialText, ...style],
    },
    color
  );
};
function Preview(_ref2) {
  let { style = {}, textStyle = {}, colorFormat = 'hex', hideInitialColor = false, hideText = false } = _ref2;
  const { hueValue, saturationValue, brightnessValue, alphaValue, returnedResults, value } = (0, _react.useContext)(
    _AppContext.default
  );
  const justifyContent = (0, _utils.getStyle)(style, 'justifyContent') ?? 'center';

  // To track changes in the color channel values of the ReText component.
  const colorHash = [hueValue, saturationValue, brightnessValue, alphaValue];
  const initialColorText = (0, _react.useMemo)(() => {
    const adaptiveTextColor =
      alphaValue.value > 0.5
        ? value
        : {
            h: 0,
            s: 0,
            v: 70,
          };
    const contrast = _colorKit.default.contrastRatio(adaptiveTextColor, '#fff');
    const color = contrast < 4.5 ? '#000' : '#fff';
    return {
      formatted: returnedResults()[colorFormat],
      color,
    };
  }, [value, colorFormat]);
  const textColor = (0, _reactNativeReanimated.useSharedValue)('#fff');
  const textColorStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = () => ({
        color: textColor.value,
      });
      _f._closure = {
        textColor,
      };
      _f.asString = 'function _f(){const{textColor}=jsThis._closure;{return{color:textColor.value};}}';
      _f.__workletHash = 14472989744818;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Preview.tsx (52:42)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  const setTextColor = color1 => {
    const color = textColor.value === '#ffffff' ? '#000000' : '#ffffff';
    const contrast = _colorKit.default.contrastRatio(color1, textColor.value);
    textColor.value = contrast < 4.5 ? color : textColor.value;
  };
  const previewColor = (0, _reactNativeReanimated.useSharedValue)('#fff');
  const previewColorStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = () => ({
        backgroundColor: previewColor.value,
      });
      _f._closure = {
        previewColor,
      };
      _f.asString = 'function _f(){const{previewColor}=jsThis._closure;{return{backgroundColor:previewColor.value};}}';
      _f.__workletHash = 9056204683932;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Preview.tsx (60:45)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  const setPreviewColor = color => {
    previewColor.value = _colorKit.default.HEX(color);
  };

  // When the values of channels change
  (0, _reactNativeReanimated.useDerivedValue)(
    (function () {
      const _f = function () {
        const currentColor = {
          h: hueValue.value,
          s: saturationValue.value,
          v: brightnessValue.value,
          a: alphaValue.value,
        };
        const adaptiveTextColor =
          alphaValue.value > 0.5
            ? currentColor
            : {
                h: 0,
                s: 0,
                v: 70,
              };
        (0, _reactNativeReanimated.runOnJS)(setPreviewColor)(currentColor);
        (0, _reactNativeReanimated.runOnJS)(setTextColor)(adaptiveTextColor);
      };
      _f._closure = {
        hueValue,
        saturationValue,
        brightnessValue,
        alphaValue,
        runOnJS: _reactNativeReanimated.runOnJS,
        setPreviewColor,
        setTextColor,
      };
      _f.asString =
        'function _f(){const{hueValue,saturationValue,brightnessValue,alphaValue,runOnJS,setPreviewColor,setTextColor}=jsThis._closure;{const currentColor={h:hueValue.value,s:saturationValue.value,v:brightnessValue.value,a:alphaValue.value};const adaptiveTextColor=alphaValue.value>0.5?currentColor:{h:0,s:0,v:70};runOnJS(setPreviewColor)(currentColor);runOnJS(setTextColor)(adaptiveTextColor);}}';
      _f.__workletHash = 1063704335960;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Preview.tsx (66:18)';
      return _f;
    })()
  );
  return /*#__PURE__*/ _react.default.createElement(
    Wrapper,
    {
      style: style,
    },
    /*#__PURE__*/ _react.default.createElement(
      _utils.ConditionalRendering,
      {
        render: !hideInitialColor,
      },
      /*#__PURE__*/ _react.default.createElement(
        _reactNative.View,
        {
          style: [
            _styles.styles.previewContainer,
            {
              backgroundColor: value,
              justifyContent,
            },
          ],
        },
        /*#__PURE__*/ _react.default.createElement(
          _utils.ConditionalRendering,
          {
            render: !hideText,
          },
          /*#__PURE__*/ _react.default.createElement(
            _reactNative.Text,
            {
              style: [
                {
                  color: initialColorText.color,
                },
                _styles.styles.previewInitialText,
                textStyle,
              ],
            },
            initialColorText.formatted
          )
        )
      )
    ),
    /*#__PURE__*/ _react.default.createElement(
      _reactNativeReanimated.default.View,
      {
        style: [
          _styles.styles.previewContainer,
          {
            justifyContent,
          },
          previewColorStyle,
        ],
      },
      /*#__PURE__*/ _react.default.createElement(
        _utils.ConditionalRendering,
        {
          render: !hideText,
        },
        /*#__PURE__*/ _react.default.createElement(ReText, {
          text: () => returnedResults()[colorFormat],
          hash: colorHash,
          style: [textStyle, textColorStyle],
        })
      )
    )
  );
}
function Wrapper(_ref3) {
  let { children, style } = _ref3;
  if (_utils.isWeb) {
    return /*#__PURE__*/ _react.default.createElement(
      _reactNative.View,
      {
        style: [_styles.styles.previewWrapper, previewWrapperWeb, style],
      },
      children
    );
  }
  return /*#__PURE__*/ _react.default.createElement(
    _reactNative.ImageBackground,
    {
      source: require('../assets/transparent-texture.png'),
      resizeMode: 'repeat',
      style: [_styles.styles.previewWrapper, style],
    },
    children
  );
}
const previewWrapperWeb = {
  backgroundImage:
    'repeating-linear-gradient(45deg, #c1c1c1 25%, transparent 25%, transparent 75%, #c1c1c1 75%, #c1c1c1), repeating-linear-gradient(45deg, #c1c1c1 25%, #fff 25%, #fff 75%, #c1c1c1 75%, #c1c1c1)',
  backgroundPosition: '0px 0px, 8px 8px',
  backgroundSize: '16px 16px',
};
//# sourceMappingURL=Preview.js.map
