'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.PreviewText = PreviewText;
var _react = _interopRequireWildcard(require('react'));
var _reactNative = require('react-native');
var _reactNativeReanimated = require('react-native-reanimated');
var _AppContext = _interopRequireDefault(require('../AppContext'));
var _styles = require('../styles');
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}
function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function (nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}
function PreviewText(_ref) {
  let { style = {}, colorFormat = 'hex' } = _ref;
  const { returnedResults, hueValue, saturationValue, brightnessValue, alphaValue } = (0, _react.useContext)(_AppContext.default);
  const [text, setText] = (0, _react.useState)(returnedResults()[colorFormat]);
  const updateText = () => {
    setText(returnedResults()[colorFormat]);
  };
  (0, _reactNativeReanimated.useDerivedValue)(
    (function () {
      const _f = function () {
        // To track changes in the color channel values of the ReText component.
        [hueValue.value, saturationValue.value, brightnessValue.value, alphaValue.value];
        (0, _reactNativeReanimated.runOnJS)(updateText)();
      };
      _f._closure = {
        hueValue,
        saturationValue,
        brightnessValue,
        alphaValue,
        runOnJS: _reactNativeReanimated.runOnJS,
        updateText,
      };
      _f.asString =
        'function _f(){const{hueValue,saturationValue,brightnessValue,alphaValue,runOnJS,updateText}=jsThis._closure;{[hueValue.value,saturationValue.value,brightnessValue.value,alphaValue.value];runOnJS(updateText)();}}';
      _f.__workletHash = 8119592659489;
      _f.__location = 'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\PreviewText.tsx (19:18)';
      return _f;
    })(),
    [colorFormat]
  );
  return /*#__PURE__*/ _react.default.createElement(
    _reactNative.Text,
    {
      style: [_styles.styles.previewText, style],
    },
    text
  );
}
//# sourceMappingURL=PreviewText.js.map
