'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.OpacitySlider = OpacitySlider;
var _react = _interopRequireWildcard(require('react'));
var _reactNativeGestureHandler = require('react-native-gesture-handler');
var _reactNativeReanimated = _interopRequireWildcard(require('react-native-reanimated'));
var _utils = require('../../utils');
var _AppContext = _interopRequireDefault(require('../../AppContext'));
var _Thumb = _interopRequireDefault(require('../Thumb/Thumb'));
var _reactNative = require('react-native');
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}
function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function (nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}
function OpacitySlider(_ref) {
  let {
    adaptSpectrum: localAdaptSpectrum,
    thumbShape: localThumbShape,
    thumbSize: localThumbSize,
    thumbColor: localThumbColor,
    boundedThumb: localBoundedThumb,
    renderThumb: localRenderThumb,
    thumbStyle: localThumbStyle,
    thumbInnerStyle: localThumbInnerStyle,
    sliderThickness: localSliderThickness,
    style = {},
    vertical = false,
    reverse = false,
  } = _ref;
  const {
    hueValue,
    saturationValue,
    brightnessValue,
    alphaValue,
    onGestureChange,
    onGestureEnd,
    adaptSpectrum: globalAdaptSpectrum,
    thumbSize: globalThumbsSize,
    thumbShape: globalThumbsShape,
    thumbColor: globalThumbsColor,
    boundedThumb: globalBoundedThumb,
    renderThumb: globalRenderThumbs,
    thumbStyle: globalThumbsStyle,
    thumbInnerStyle: globalThumbsInnerStyle,
    sliderThickness: globalSliderThickness,
  } = (0, _react.useContext)(_AppContext.default);
  const thumbShape = localThumbShape ?? globalThumbsShape,
    thumbSize = localThumbSize ?? globalThumbsSize,
    thumbColor = localThumbColor ?? globalThumbsColor,
    boundedThumb = localBoundedThumb ?? globalBoundedThumb,
    renderThumb = localRenderThumb ?? globalRenderThumbs,
    thumbStyle = localThumbStyle ?? globalThumbsStyle ?? {},
    thumbInnerStyle = localThumbInnerStyle ?? globalThumbsInnerStyle ?? {},
    adaptSpectrum = localAdaptSpectrum ?? globalAdaptSpectrum,
    sliderThickness = localSliderThickness ?? globalSliderThickness;
  const borderRadius = (0, _utils.getStyle)(style, 'borderRadius') ?? 5,
    getWidth = (0, _utils.getStyle)(style, 'width'),
    getHeight = (0, _utils.getStyle)(style, 'height');
  const width = (0, _reactNativeReanimated.useSharedValue)(
      vertical ? sliderThickness : typeof getWidth === 'number' ? getWidth : 0
    ),
    height = (0, _reactNativeReanimated.useSharedValue)(
      !vertical ? sliderThickness : typeof getHeight === 'number' ? getHeight : 0
    );
  const handleScale = (0, _reactNativeReanimated.useSharedValue)(1);
  const handleStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = function () {
        const length = (vertical ? height.value : width.value) - (boundedThumb ? thumbSize : 0),
          percent = alphaValue.value * length,
          pos = (reverse ? length - percent : percent) - (boundedThumb ? 0 : thumbSize / 2),
          posY = vertical ? pos : height.value / 2 - thumbSize / 2,
          posX = vertical ? width.value / 2 - thumbSize / 2 : pos;
        return {
          transform: [
            {
              translateY: posY,
            },
            {
              translateX: posX,
            },
            {
              scale: handleScale.value,
            },
          ],
        };
      };
      _f._closure = {
        vertical,
        height,
        width,
        boundedThumb,
        thumbSize,
        alphaValue,
        reverse,
        handleScale,
      };
      _f.asString =
        'function _f(){const{vertical,height,width,boundedThumb,thumbSize,alphaValue,reverse,handleScale}=jsThis._closure;{const length=(vertical?height.value:width.value)-(boundedThumb?thumbSize:0),percent=alphaValue.value*length,pos=(reverse?length-percent:percent)-(boundedThumb?0:thumbSize/2),posY=vertical?pos:height.value/2-thumbSize/2,posX=vertical?width.value/2-thumbSize/2:pos;return{transform:[{translateY:posY},{translateX:posX},{scale:handleScale.value}]};}}';
      _f.__workletHash = 14619937170836;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Sliders\\OpacitySlider.tsx (64:39)';
      _f.__optimalization = 3;
      return _f;
    })(),
    [localThumbSize, vertical, reverse]
  );
  const activeColorStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = function () {
        if (!_utils.isWeb)
          return {
            backgroundColor: '#0000',
          };
        const deg = vertical ? (reverse ? 1 : 180) : reverse ? 270 : 90;
        const color = (0, _utils.HSVA2HSLA)(
          hueValue.value,
          adaptSpectrum ? saturationValue.value : 100,
          adaptSpectrum ? brightnessValue.value : 100
        );
        return {
          background: `linear-gradient(${deg}deg, transparent 0%, ${color} 100%)`,
        };
      };
      _f._closure = {
        isWeb: _utils.isWeb,
        vertical,
        reverse,
        HSVA2HSLA: _utils.HSVA2HSLA,
        hueValue,
        adaptSpectrum,
        saturationValue,
        brightnessValue,
      };
      _f.asString =
        'function _f(){const{isWeb,vertical,reverse,HSVA2HSLA,hueValue,adaptSpectrum,saturationValue,brightnessValue}=jsThis._closure;{if(!isWeb)return{backgroundColor:\'#0000\'};const deg=vertical?reverse?1:180:reverse?270:90;const color=HSVA2HSLA(hueValue.value,adaptSpectrum?saturationValue.value:100,adaptSpectrum?brightnessValue.value:100);return{background:"linear-gradient("+deg+"deg, transparent 0%, "+color+" 100%)"};}}';
      _f.__workletHash = 11438268282178;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Sliders\\OpacitySlider.tsx (75:44)';
      return _f;
    })()
  );
  const onGestureUpdate = (function () {
    const _f = function (_ref2) {
      let { x, y } = _ref2;
      const length = (vertical ? height.value : width.value) - (boundedThumb ? thumbSize : 0),
        posX = (0, _utils.clamp)((vertical ? y : x) - (boundedThumb ? thumbSize / 2 : 0), length),
        value = posX / length,
        newOpacityValue = reverse ? 1 - value : value;
      if (alphaValue.value === newOpacityValue) return;
      alphaValue.value = newOpacityValue;
      (0, _reactNativeReanimated.runOnJS)(onGestureChange)();
    };
    _f._closure = {
      vertical,
      height,
      width,
      boundedThumb,
      thumbSize,
      clamp: _utils.clamp,
      reverse,
      alphaValue,
      runOnJS: _reactNativeReanimated.runOnJS,
      onGestureChange,
    };
    _f.asString =
      'function _f({x:x,y:y}){const{vertical,height,width,boundedThumb,thumbSize,clamp,reverse,alphaValue,runOnJS,onGestureChange}=jsThis._closure;{const length=(vertical?height.value:width.value)-(boundedThumb?thumbSize:0),posX=clamp((vertical?y:x)-(boundedThumb?thumbSize/2:0),length),value=posX/length,newOpacityValue=reverse?1-value:value;if(alphaValue.value===newOpacityValue)return;alphaValue.value=newOpacityValue;runOnJS(onGestureChange)();}}';
    _f.__workletHash = 2635869256393;
    _f.__location =
      'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Sliders\\OpacitySlider.tsx (88:26)';
    return _f;
  })();
  const onGestureBegin = (function () {
    const _f = function (event) {
      handleScale.value = (0, _reactNativeReanimated.withTiming)(1.2, {
        duration: 100,
      });
      onGestureUpdate(event);
    };
    _f._closure = {
      handleScale,
      withTiming: _reactNativeReanimated.withTiming,
      onGestureUpdate,
    };
    _f.asString =
      'function _f(event){const{handleScale,withTiming,onGestureUpdate}=jsThis._closure;{handleScale.value=withTiming(1.2,{duration:100});onGestureUpdate(event);}}';
    _f.__workletHash = 14773240202957;
    _f.__location =
      'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Sliders\\OpacitySlider.tsx (101:25)';
    return _f;
  })();
  const onGestureFinish = (function () {
    const _f = function () {
      handleScale.value = (0, _reactNativeReanimated.withTiming)(1, {
        duration: 100,
      });
      (0, _reactNativeReanimated.runOnJS)(onGestureEnd)();
    };
    _f._closure = {
      handleScale,
      withTiming: _reactNativeReanimated.withTiming,
      runOnJS: _reactNativeReanimated.runOnJS,
      onGestureEnd,
    };
    _f.asString =
      'function _f(){const{handleScale,withTiming,runOnJS,onGestureEnd}=jsThis._closure;{handleScale.value=withTiming(1,{duration:100});runOnJS(onGestureEnd)();}}';
    _f.__workletHash = 6379049506140;
    _f.__location =
      'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Sliders\\OpacitySlider.tsx (106:26)';
    return _f;
  })();
  const pan = _reactNativeGestureHandler.Gesture.Pan().onBegin(onGestureBegin).onUpdate(onGestureUpdate).onEnd(onGestureFinish);
  const tap = _reactNativeGestureHandler.Gesture.Tap().onTouchesUp(onGestureFinish);
  const longPress = _reactNativeGestureHandler.Gesture.LongPress().onTouchesUp(onGestureFinish);
  const composed = _reactNativeGestureHandler.Gesture.Exclusive(pan, tap, longPress);
  const onLayout = _ref3 => {
    let {
      nativeEvent: { layout },
    } = _ref3;
    if (!vertical)
      width.value = (0, _reactNativeReanimated.withTiming)(layout.width, {
        duration: 5,
      });
    if (vertical)
      height.value = (0, _reactNativeReanimated.withTiming)(layout.height, {
        duration: 5,
      });
  };
  const imageStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = function () {
        if (_utils.isWeb) return {};
        const imageRotate = vertical ? (reverse ? '90deg' : '270deg') : reverse ? '0deg' : '180deg';
        const imageTranslateY =
          ((height.value - width.value) / 2) * ((reverse && _utils.isRtl) || (!reverse && !_utils.isRtl) ? -1 : 1);
        return {
          width: vertical ? height.value : '100%',
          height: vertical ? width.value : '100%',
          tintColor: (0, _utils.HSVA2HSLA)(
            hueValue.value,
            adaptSpectrum ? saturationValue.value : 100,
            adaptSpectrum ? brightnessValue.value : 100
          ),
          borderRadius,
          transform: [
            {
              rotate: imageRotate,
            },
            {
              translateX: vertical ? ((height.value - width.value) / 2) * (reverse ? 1 : -1) : 0,
            },
            {
              translateY: vertical ? imageTranslateY : 0,
            },
          ],
        };
      };
      _f._closure = {
        isWeb: _utils.isWeb,
        vertical,
        reverse,
        height,
        width,
        isRtl: _utils.isRtl,
        HSVA2HSLA: _utils.HSVA2HSLA,
        hueValue,
        adaptSpectrum,
        saturationValue,
        brightnessValue,
        borderRadius,
      };
      _f.asString =
        "function _f(){const{isWeb,vertical,reverse,height,width,isRtl,HSVA2HSLA,hueValue,adaptSpectrum,saturationValue,brightnessValue,borderRadius}=jsThis._closure;{if(isWeb)return{};const imageRotate=vertical?reverse?'90deg':'270deg':reverse?'0deg':'180deg';const imageTranslateY=(height.value-width.value)/2*(reverse&&isRtl||!reverse&&!isRtl?-1:1);return{width:vertical?height.value:'100%',height:vertical?width.value:'100%',tintColor:HSVA2HSLA(hueValue.value,adaptSpectrum?saturationValue.value:100,adaptSpectrum?brightnessValue.value:100),borderRadius:borderRadius,transform:[{rotate:imageRotate},{translateX:vertical?(height.value-width.value)/2*(reverse?1:-1):0},{translateY:vertical?imageTranslateY:0}]};}}";
      _f.__workletHash = 12900498321753;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Sliders\\OpacitySlider.tsx (122:38)';
      return _f;
    })(),
    [vertical, reverse, sliderThickness]
  );
  const thicknessStyle = vertical
    ? {
        width: sliderThickness,
      }
    : {
        height: sliderThickness,
      };
  return /*#__PURE__*/ _react.default.createElement(
    _reactNativeGestureHandler.GestureDetector,
    {
      gesture: composed,
    },
    /*#__PURE__*/ _react.default.createElement(
      _reactNativeReanimated.default.View,
      {
        onLayout: onLayout,
        style: [
          {
            borderRadius,
          },
          style,
          {
            position: 'relative',
            borderWidth: 0,
            padding: 0,
          },
          thicknessStyle,
          _utils.isWeb ? webTransparentTexture : {},
        ],
      },
      /*#__PURE__*/ _react.default.createElement(
        _utils.RenderNativeOnly,
        null,
        /*#__PURE__*/ _react.default.createElement(_reactNative.Image, {
          source: require('../../assets/transparent-texture.png'),
          style: [
            {
              width: '100%',
              height: '100%',
              borderRadius,
            },
            _reactNative.StyleSheet.absoluteFill,
          ],
          resizeMode: 'repeat',
        }),
        /*#__PURE__*/ _react.default.createElement(_reactNativeReanimated.default.Image, {
          source: require('../../assets/blackGradient.png'),
          style: imageStyle,
          resizeMode: 'stretch',
        })
      ),
      /*#__PURE__*/ _react.default.createElement(
        _utils.RenderWebOnly,
        null,
        /*#__PURE__*/ _react.default.createElement(_reactNativeReanimated.default.View, {
          style: [
            {
              flex: 1,
              borderRadius,
            },
            activeColorStyle,
          ],
        })
      ),
      /*#__PURE__*/ _react.default.createElement(_Thumb.default, {
        channel: 'a',
        thumbShape,
        thumbSize,
        thumbColor,
        renderThumb,
        handleStyle,
        innerStyle: thumbInnerStyle,
        style: thumbStyle,
        vertical,
        adaptSpectrum,
      })
    )
  );
}
const webTransparentTexture = {
  flex: undefined,
  backgroundImage:
    'repeating-linear-gradient(45deg, #c1c1c1 25%, transparent 25%, transparent 75%, #c1c1c1 75%, #c1c1c1), repeating-linear-gradient(45deg, #c1c1c1 25%, #fff 25%, #fff 75%, #c1c1c1 75%, #c1c1c1)',
  backgroundPosition: '0px 0px, 8px 8px',
  backgroundSize: '16px 16px',
};
//# sourceMappingURL=OpacitySlider.js.map
