'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true,
});
exports.default = Ring;
var _react = _interopRequireDefault(require('react'));
var _reactNativeReanimated = _interopRequireWildcard(require('react-native-reanimated'));
var _colorKit = _interopRequireDefault(require('../../../colorKit/colorKit'));
var _styles = require('../../../styles');
function _getRequireWildcardCache(nodeInterop) {
  if (typeof WeakMap !== 'function') return null;
  var cacheBabelInterop = new WeakMap();
  var cacheNodeInterop = new WeakMap();
  return (_getRequireWildcardCache = function (nodeInterop) {
    return nodeInterop ? cacheNodeInterop : cacheBabelInterop;
  })(nodeInterop);
}
function _interopRequireWildcard(obj, nodeInterop) {
  if (!nodeInterop && obj && obj.__esModule) {
    return obj;
  }
  if (obj === null || (typeof obj !== 'object' && typeof obj !== 'function')) {
    return { default: obj };
  }
  var cache = _getRequireWildcardCache(nodeInterop);
  if (cache && cache.has(obj)) {
    return cache.get(obj);
  }
  var newObj = {};
  var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;
  for (var key in obj) {
    if (key !== 'default' && Object.prototype.hasOwnProperty.call(obj, key)) {
      var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;
      if (desc && (desc.get || desc.set)) {
        Object.defineProperty(newObj, key, desc);
      } else {
        newObj[key] = obj[key];
      }
    }
  }
  newObj.default = obj;
  if (cache) {
    cache.set(obj, newObj);
  }
  return newObj;
}
function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}
function Ring(_ref) {
  let { width, height, borderRadius, thumbColor, adaptiveColor, handleStyle, innerStyle, solidColor, style } = _ref;
  const thumb_Color = thumbColor ? _colorKit.default.HEX(thumbColor) : undefined;
  const computedStyle = {
    width,
    height,
    borderRadius,
    backgroundColor: (thumb_Color || '#ffffff') + 50,
    borderColor: thumbColor,
    borderWidth: 1,
  };
  const adaptiveColorStyle = (0, _reactNativeReanimated.useAnimatedStyle)(
    (function () {
      const _f = () => ({
        backgroundColor: (thumbColor && thumbColor + '50') || (adaptiveColor.value === '#ffffff' ? '#ffffff50' : '#00000050'),
        borderColor: thumbColor || adaptiveColor.value,
      });
      _f._closure = {
        thumbColor,
        adaptiveColor,
      };
      _f.asString =
        "function _f(){const{thumbColor,adaptiveColor}=jsThis._closure;{return{backgroundColor:thumbColor&&thumbColor+'50'||(adaptiveColor.value==='#ffffff'?'#ffffff50':'#00000050'),borderColor:thumbColor||adaptiveColor.value};}}";
      _f.__workletHash = 15281051466529;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Thumb\\BuiltinThumbs\\Ring.tsx (29:46)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  return /*#__PURE__*/ _react.default.createElement(
    _reactNativeReanimated.default.View,
    {
      style: [_styles.styles.handle, style, computedStyle, adaptiveColorStyle, handleStyle],
    },
    /*#__PURE__*/ _react.default.createElement(_reactNativeReanimated.default.View, {
      style: [
        _styles.styles.shadow,
        {
          borderRadius,
          zIndex: 100,
          width: Math.round(width * 0.75),
          height: Math.round(width * 0.75),
        },
        solidColor,
        innerStyle,
      ],
    })
  );
}
//# sourceMappingURL=Ring.js.map
