import React from 'react';
import { View } from 'react-native';
import Animated, { useAnimatedStyle } from 'react-native-reanimated';
import { isRtl } from '../../../utils';
import { styles } from '../../../styles';
export default function DoubleTriangle(_ref) {
  let { width, height, thumbColor, adaptiveColor, handleStyle, innerStyle, style, vertical } = _ref;
  const computedStyle = {
    width,
    height,
    flexDirection: vertical ? (isRtl ? 'row' : 'row-reverse') : 'column',
  };
  const triangleUpStyle = {
    borderBottomWidth: 10,
    borderLeftWidth: 5,
    borderRightWidth: 5,
    transform: [
      {
        rotate: vertical ? '90deg' : '0deg',
      },
    ],
  };
  const triangleDownStyle = {
    borderBottomWidth: 10,
    borderLeftWidth: 5,
    borderRightWidth: 5,
    transform: [
      {
        rotate: vertical ? '270deg' : '180deg',
      },
    ],
  };
  const adaptiveColorStyle = useAnimatedStyle(
    (function () {
      const _f = () => ({
        borderBottomColor: thumbColor || adaptiveColor.value,
      });
      _f._closure = {
        thumbColor,
        adaptiveColor,
      };
      _f.asString =
        'function _f(){const{thumbColor,adaptiveColor}=jsThis._closure;{return{borderBottomColor:thumbColor||adaptiveColor.value};}}';
      _f.__workletHash = 6327519840893;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Thumb\\BuiltinThumbs\\DoubleTriangle.tsx (37:46)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  return /*#__PURE__*/ React.createElement(
    Animated.View,
    {
      style: [styles.handle, style, computedStyle, handleStyle],
    },
    /*#__PURE__*/ React.createElement(Animated.View, {
      style: [styles.triangle, triangleDownStyle, adaptiveColorStyle, innerStyle],
    }),
    /*#__PURE__*/ React.createElement(View, {
      style: {
        width: '50%',
        height: '50%',
      },
    }),
    /*#__PURE__*/ React.createElement(Animated.View, {
      style: [styles.triangle, triangleUpStyle, adaptiveColorStyle, innerStyle],
    })
  );
}
//# sourceMappingURL=DoubleTriangle.js.map
