import React from 'react';
import Animated, { useAnimatedStyle } from 'react-native-reanimated';
import { styles } from '../../../styles';
export default function Hollow(_ref) {
  let { width, height, borderRadius, thumbColor, adaptiveColor, handleStyle, innerStyle, style } = _ref;
  const computedStyle = {
    width,
    height,
    borderRadius,
    borderWidth: 2,
  };
  const adaptiveColorStyle = useAnimatedStyle(
    (function () {
      const _f = () => ({
        borderColor: thumbColor || adaptiveColor.value,
      });
      _f._closure = {
        thumbColor,
        adaptiveColor,
      };
      _f.asString =
        'function _f(){const{thumbColor,adaptiveColor}=jsThis._closure;{return{borderColor:thumbColor||adaptiveColor.value};}}';
      _f.__workletHash = 6935533137874;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Thumb\\BuiltinThumbs\\Hollow.tsx (19:46)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  const adaptiveColorBgStyle = useAnimatedStyle(
    (function () {
      const _f = () => ({
        backgroundColor: thumbColor || adaptiveColor.value,
      });
      _f._closure = {
        thumbColor,
        adaptiveColor,
      };
      _f.asString =
        'function _f(){const{thumbColor,adaptiveColor}=jsThis._closure;{return{backgroundColor:thumbColor||adaptiveColor.value};}}';
      _f.__workletHash = 7964224910800;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Thumb\\BuiltinThumbs\\Hollow.tsx (20:48)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  return /*#__PURE__*/ React.createElement(
    Animated.View,
    {
      style: [styles.handle, style, computedStyle, adaptiveColorStyle, handleStyle],
    },
    /*#__PURE__*/ React.createElement(Animated.View, {
      style: [
        {
          width: 4,
          height: 4,
          borderRadius: 2,
        },
        adaptiveColorBgStyle,
        styles.shadow,
        innerStyle,
      ],
    })
  );
}
//# sourceMappingURL=Hollow.js.map
