import React from 'react';
import Animated, { useAnimatedStyle } from 'react-native-reanimated';
import { styles } from '../../../styles';
export default function Pill(_ref) {
  let { width, height, borderRadius, thumbColor, adaptiveColor, handleStyle, innerStyle, style, vertical } = _ref;
  const computedStyle = {
    width,
    height,
  };
  const pillStyle = {
    borderRadius,
    borderColor: thumbColor,
    borderWidth: 2,
    width: vertical ? '100%' : 10,
    height: vertical ? 10 : '100%',
  };
  const adaptiveColorStyle = useAnimatedStyle(
    (function () {
      const _f = () => ({
        borderColor: thumbColor || adaptiveColor.value,
      });
      _f._closure = {
        thumbColor,
        adaptiveColor,
      };
      _f.asString =
        'function _f(){const{thumbColor,adaptiveColor}=jsThis._closure;{return{borderColor:thumbColor||adaptiveColor.value};}}';
      _f.__workletHash = 6935533137874;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Thumb\\BuiltinThumbs\\Pill.tsx (27:46)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  return /*#__PURE__*/ React.createElement(
    Animated.View,
    {
      style: [styles.handle, computedStyle, style, handleStyle],
    },
    /*#__PURE__*/ React.createElement(Animated.View, {
      style: [pillStyle, styles.shadow, adaptiveColorStyle, innerStyle],
    })
  );
}
//# sourceMappingURL=Pill.js.map
