import React from 'react';
import Animated, { useAnimatedStyle } from 'react-native-reanimated';
import colorKit from '../../../colorKit/colorKit';
import { styles } from '../../../styles';
export default function Ring(_ref) {
  let { width, height, borderRadius, thumbColor, adaptiveColor, handleStyle, innerStyle, solidColor, style } = _ref;
  const thumb_Color = thumbColor ? colorKit.HEX(thumbColor) : undefined;
  const computedStyle = {
    width,
    height,
    borderRadius,
    backgroundColor: (thumb_Color || '#ffffff') + 50,
    borderColor: thumbColor,
    borderWidth: 1,
  };
  const adaptiveColorStyle = useAnimatedStyle(
    (function () {
      const _f = () => ({
        backgroundColor: (thumbColor && thumbColor + '50') || (adaptiveColor.value === '#ffffff' ? '#ffffff50' : '#00000050'),
        borderColor: thumbColor || adaptiveColor.value,
      });
      _f._closure = {
        thumbColor,
        adaptiveColor,
      };
      _f.asString =
        "function _f(){const{thumbColor,adaptiveColor}=jsThis._closure;{return{backgroundColor:thumbColor&&thumbColor+'50'||(adaptiveColor.value==='#ffffff'?'#ffffff50':'#00000050'),borderColor:thumbColor||adaptiveColor.value};}}";
      _f.__workletHash = 15281051466529;
      _f.__location =
        'D:\\Development\\--- Packages ---\\reanimated-color-picker\\src\\components\\Thumb\\BuiltinThumbs\\Ring.tsx (29:46)';
      _f.__optimalization = 3;
      return _f;
    })()
  );
  return /*#__PURE__*/ React.createElement(
    Animated.View,
    {
      style: [styles.handle, style, computedStyle, adaptiveColorStyle, handleStyle],
    },
    /*#__PURE__*/ React.createElement(Animated.View, {
      style: [
        styles.shadow,
        {
          borderRadius,
          zIndex: 100,
          width: Math.round(width * 0.75),
          height: Math.round(width * 0.75),
        },
        solidColor,
        innerStyle,
      ],
    })
  );
}
//# sourceMappingURL=Ring.js.map
