import type namedColors from './namedColors';
export declare type ColorFormats =
  | 'hex3'
  | 'hex4'
  | 'hex6'
  | 'hex8'
  | 'hsl'
  | 'hsla'
  | 'rgb'
  | 'rgba'
  | 'hsva'
  | 'hsv'
  | 'hwba'
  | 'hwb';
export declare type ColorString = keyof typeof namedColors | string;
export declare type rgbaT = {
  r: number;
  g: number;
  b: number;
  a: number;
};
export declare type rgbT = Omit<rgbaT, 'a'>;
export declare type hslaT = {
  h: number;
  s: number;
  l: number;
  a: number;
};
export declare type hslT = Omit<hslaT, 'a'>;
export declare type hsvaT = {
  h: number;
  s: number;
  v: number;
  a: number;
};
export declare type hsvT = Omit<hsvaT, 'a'>;
export declare type hwbaT = {
  h: number;
  w: number;
  b: number;
  a: number;
};
export declare type hwbT = Omit<hwbaT, 'a'>;
export declare type SupportedColorFormats = ColorString | rgbaT | rgbT | hslaT | hslT | hsvaT | hsvT | hwbaT | hwbT | number;
export declare type colorTypes<T extends {}> = {
  object: () => T;
  string: (alpha?: boolean) => string;
  array: () => number[];
};
export declare type ConversionMethods = {
  hex: () => string;
  rgb: () => colorTypes<rgbaT>;
  hsl: () => colorTypes<hslaT>;
  hsv: () => colorTypes<hsvaT>;
  hwb: () => colorTypes<hwbaT>;
};
//# sourceMappingURL=types.d.ts.map
